Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/Transformation.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/Transformation.cs	(revision 10667)
+++ 	(revision )
@@ -1,42 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
-
-namespace HeuristicLab.DataPreprocessing.Implementations {
-  public abstract class Transformation {
-
-    protected ITransactionalPreprocessingData preprocessingData;
-
-    protected string column;
-
-    protected Transformation(ITransactionalPreprocessingData preprocessingData, string column) {
-      this.preprocessingData = preprocessingData;
-      this.column = column;
-    }
-
-    public abstract void Transform();
-
-    public abstract ISymbolicExpressionTree GenerateInverseTransformation();
-
-    public abstract void Check();
-  }
-}
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/Transformations/Transformation.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/Transformations/Transformation.cs	(revision 10669)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/Transformations/Transformation.cs	(revision 10669)
@@ -0,0 +1,50 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+
+namespace HeuristicLab.DataPreprocessing.Transformations {
+  [Item("Transformation", "Represents the base class for a transformation.")]
+  public abstract class Transformation : ParameterizedNamedItem {
+
+    protected ITransactionalPreprocessingData PreprocessingData { get; private set; }
+
+    protected string Column { get; private set; }
+
+    protected Transformation(ITransactionalPreprocessingData preprocessingData, string column) {
+      this.PreprocessingData = preprocessingData;
+      this.Column = column;
+    }
+
+    protected Transformation(Transformation original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public abstract void Transform();
+
+    public abstract ISymbolicExpressionTree GenerateInverseTransformation();
+
+    public abstract void Check();
+
+  }
+}